/*
 File: dbl_colonsym.cpp
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#include "dbl_colon.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_dbl_colon;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_dbl_colon::TH_dbl_colon(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_dbl_colon;
  NS_dbl_colon::Cdbl_colon Cdbl_colon_;// parallel-parser's parse table
#define ssPARSE_TABLE Cdbl_colon_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_dbl_colon::PROC_TH_dbl_colon(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_dbl_colon";
  static bool one_time(false);
  static NS_dbl_colon::Cdbl_colon* NS_dbl_colon_Cdbl_colon_(0);// parallel-parser's fsm table
  static Parser* NS_dbl_colon_Cdbl_colon_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_dbl_colon_Cdbl_colon_ = new NS_dbl_colon::Cdbl_colon();// parallel-parser's fsm table
    NS_dbl_colon_Cdbl_colon_parser = new Parser(*NS_dbl_colon_Cdbl_colon_,Caller_pp);
  }
 proc_parser = NS_dbl_colon_Cdbl_colon_parser;
#include "wproc_pp_core.h"
}
void 
Cdbl_colon::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rdbl_colon_:{
       Rdbl_colon* sym;
     if(re->rule_ == 0){
       sym = new Rdbl_colon(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdbl_colon*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    default: return;
   }
}
